# - name: Check for Secret gitlab-registry in Namespace "{{ k8s_namespace }}"
#   k8s_info:
#     api_version: v1
#     kind: Secret
#     name: "private-registry-pull-secret"
#     namespace: "{{ k8s_namespace }}"
#     kubeconfig: "{{ k8s_config }}"
#   register: registry_secret

- name: "Registry Secret: Remove Secret private-registry-pull-secret in Namespace {{ k8s_namespace }}"
  k8s:
    state: absent
    api_version: v1
    kind: Secret
    namespace: "{{ k8s_namespace }}"
    name: "private-registry-pull-secret"
  ignore_errors: true

- name: "Registry Secret: Set facts for dockerconfigjson"
  ansible.builtin.set_fact:
    docker_registry: "private-registry-pull-secret"
    docker_server: "{{ inv_op_stack.private_registry.registry_url }}"
    docker_email: "{{ inv_op_stack.private_registry.registry_user_email }}"
    docker_username: "{{ inv_op_stack.private_registry.registry_username }}"
    docker_password: "{{ inv_op_stack.private_registry.registry_password }}"
    cacheable: no
  when: inv_op_stack is defined and inv_op_stack.private_registry is defined and inv_op_stack.private_registry.enable == true

- name: "Registry Secret: Set facts for dockerconfigjson"
  ansible.builtin.set_fact:
    docker_registry: "private-registry-pull-secret"
    docker_server: "registry.gitlab.com"
    docker_email: "{{ inv_k8s.gitlab_access.user_email }}"
    docker_username: "{{ inv_k8s.gitlab_access.user }}"
    docker_password: "{{ inv_k8s.gitlab_access.token }}"
    cacheable: no
  when: not inv_op_stack is defined or not inv_op_stack.private_registry is defined or inv_op_stack.private_registry.enable == false

- name: "Registry Secret: Create Docker Registry secret"
  command: kubectl --kubeconfig="{{ k8s_config }}" -n "{{ k8s_namespace }}" create secret docker-registry "{{ docker_registry }}" --docker-server="{{ docker_server }}" --docker-username="{{ docker_username }}" --docker-password="{{ docker_password }}" --docker-email="{{ docker_email }}"
  when: registry_secret['resources'][0] is undefined and docker_username is not undefined and docker_password is not undefined and docker_email is not undefined and not docker_username == "" and not docker_password == "" and not docker_email == ""
  ignore_errors: true
